using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using EMPExtNav;

namespace MyExtNav
{
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// You have to declare EMPExtNav.ExtNav as "public".
		/// All MDI-Childs need access to this class.
		/// </summary>
		public ExtNav extNav;

		private System.Windows.Forms.MainMenu mainMenu1;

		public System.IntPtr activehandle;
		public Form2 mdi_form2;
		public Form3 mdi_form3;
		public Form4 mdi_form4;
		public FormAbout mdi_About;

		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuClose;
		private System.Windows.Forms.MenuItem mnuHelp;
		private System.Windows.Forms.MenuItem mnuAbout;

		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code

		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.extNav = new EMPExtNav.ExtNav();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mnuClose = new System.Windows.Forms.MenuItem();
			this.mnuHelp = new System.Windows.Forms.MenuItem();
			this.mnuAbout = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// extNav
			// 
			this.extNav.ABackColor = System.Drawing.SystemColors.Control;
			this.extNav.AForeColor = System.Drawing.Color.Black;
			this.extNav.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(251)), ((System.Byte)(233)));
			this.extNav.CTLBackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(251)), ((System.Byte)(233)));
			this.extNav.Dock = System.Windows.Forms.DockStyle.Top;
			this.extNav.IBackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(251)), ((System.Byte)(233)));
			this.extNav.IForeColor = System.Drawing.Color.Gray;
			this.extNav.Name = "extNav";
			this.extNav.Size = new System.Drawing.Size(856, 30);
			this.extNav.TabIndex = 0;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuFile,
																					  this.mnuHelp});
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuClose});
			this.mnuFile.Text = "File";
			// 
			// mnuClose
			// 
			this.mnuClose.Index = 0;
			this.mnuClose.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
			this.mnuClose.Text = "&Close";
			this.mnuClose.Click += new System.EventHandler(this.mnuClose_Click);
			// 
			// mnuHelp
			// 
			this.mnuHelp.Index = 1;
			this.mnuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuAbout});
			this.mnuHelp.Text = "Help";
			// 
			// mnuAbout
			// 
			this.mnuAbout.Index = 0;
			this.mnuAbout.Text = "About the EMPExtNav Control";
			this.mnuAbout.Click += new System.EventHandler(this.mnuAbout_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(856, 637);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.extNav});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.IsMdiContainer = true;
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "EMPExtNav - Visual Studio like Navigation Control";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion


		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void navext_additem( string text, System.IntPtr WindowHandle ) 
		{
			activehandle = WindowHandle;
			this.extNav.add_item(text,WindowHandle);
			this.extNav.sync(WindowHandle);
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			/// 1. assign "this" to extNav.mdiparent!!!
			/// 2. init new form class
			/// 3. bind mdiparent
			/// 4. add extNav-item

			this.extNav.mdiparent = this;
			
			mdi_form4 = new Form4(this);
			mdi_form4.MdiParent = this;
			mdi_form4.Show();
			mdi_form4.Activate();
			this.navext_additem("Describe Form4", mdi_form4.Handle);

			mdi_form3 = new Form3(this);
			mdi_form3.MdiParent = this;
			mdi_form3.Show();
			mdi_form3.Activate();
			this.navext_additem("Describe Form3", mdi_form3.Handle);

			mdi_form2 = new Form2(this);
			mdi_form2.MdiParent = this;
			mdi_form2.Show();
			mdi_form2.Activate();
			this.navext_additem("Describe Form2", mdi_form2.Handle);

			mdi_About = new FormAbout(this);
			mdi_About.MdiParent = this;
			mdi_About.Show();
			mdi_About.Activate();
			this.navext_additem("About this Control", mdi_About.Handle);
		}

		private void mnuClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void mnuAbout_Click(object sender, System.EventArgs e)
		{
			if( mdi_About == null || mdi_About.IsDisposed == true ) 
				mdi_About = new FormAbout(this);
			mdi_About.MdiParent = this;
			mdi_About.Show();
			mdi_About.Activate();
			this.navext_additem("About this Control", mdi_About.Handle);
		}
	}
}
